# !/usr/bin/env python
# -*- encoding:utf-8 -*-
import json
import sys
import requests
import time

defaultencoding = 'utf-8'
if sys.getdefaultencoding() != defaultencoding:
    reload(sys)
    sys.setdefaultencoding(defaultencoding)

JOB_URL = sys.argv[1]
JOB_NAME = sys.argv[2]
BUILD_NUMBER = sys.argv[3]
GIT_BRANCH = sys.argv[4]
currenttime = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())

url = 'https://open.feishu.cn/open-apis/bot/v2/hook/538a4ea5-24ed-41d4-a79e-3301d157b5b1'
method = 'post'
headers = {
    'Content-Type': 'application/json'
}

req = requests.get('%s/%s/api/json' % (JOB_URL, BUILD_NUMBER), auth=("wancongcong", "11e4d5b508140bba942e5733ec6a1b9190"))
req = json.loads(req.text)
result = req['result']
try:
    userName = req['actions'][0]['causes'][0]['userName']
except Exception:
    userName = req['actions'][1]['causes'][0]['userName']

# for i in req['actions']:
#     try:
#         userName = i['causes'][0]['userName']
#     except Exception:
#         # userName = "未知"
#         continue

jsons = {
    "msg_type": "interactive",
    "card": {
        "config": {
            "wide_screen_mode": True,
            "enable_forward": True
        },
        "elements": [{
            "tag": "div",
            "text": {
                "content": "项目名称：" + JOB_NAME + "\n构建编号：第" + BUILD_NUMBER + "次构建\n运行时间：" + currenttime + "\n分支: " + GIT_BRANCH + "\n构建者: " + userName + "\n构建状态: " + result,
                "tag": "lark_md"
            }
        }, {
            "actions": [{
                "tag": "button",
                "text": {
                    "content": "查看报告",
                    "tag": "lark_md"
                },
                "url": JOB_URL,
                "type": "default",
                "value": {}
            }],
            "tag": "action"
        }],
        "header": {
            "title": {
                "content": JOB_NAME + " 构建报告",
                "tag": "plain_text"
            }
        }
    }
}

requests.request(method=method, url=url, headers=headers, json=jsons)
