#!/bin/bash

#  初始化一些项目权限，服务配置，启动服务
DEST=${3}
PROJECT_NAME=${2}
SERVER=${1}
PROJECT_NAME_TEST=${PROJECT_NAME#*_}

function usage() {
  
  echo "Usage: "
  echo "  ./xxx.sh [SERVER] [PROJECT_NAME] [DEST]"
  echo
  echo "Management Commands: "
  echo "传入三个参数 "
  echo "  SERVER           ansible主机名字"
  echo "  PROJECT_NAME     jenkins项目名字"
  echo "  DEST             目标项目路径"
  echo
}

# 设置权限
function fxht_permissions() {
    ansible ${SERVER} -m shell -a 'chdir='${DEST}' chmod 600 '${PROJECT_NAME}'/crontab/rsync.txt  && \
    chown nobody.nobody '${PROJECT_NAME}'/crontab/rsync.txt'
    echo "初始化 ${PROJECT_NAME} 项目权限完成"

}

# 重启 swoole
function kefu_api_swoole_restart () {
  /bin/php  ${DEST}/${PROJECT_NAME}/think swoole restart
  echo "${PROJECT_NAME} 项目 swoole 已重启"
}

# 初始化web 目录权限
function chmod_web () {
  ansible ${SERVER} -m shell -a 'chdir='${DEST}' chmod -R 777 '${PROJECT_NAME}'/resource >/dev/null || \
  chown -R nobody.nobody '${PROJECT_NAME}'/wechat'

}

if [[ $# != 3 ]];then
  usage
fi

if [[ ${PROJECT_NAME_TEST} == "server_web" ]];then
  chmod_web
fi

if [[ ${PROJECT_NAME_TEST} == "server_kefu_api" ]];then
  kefu_api_swoole_restart
fi

if [[  ${PROJECT_NAME_TEST} == "server_fxht" ]];then
  fxht_permissions
fi

if [[ ${PROJECT_NAME} == "pre_server_web" ]];then
ansible ${SERVER} -m shell -a 'chdir='${DEST}' \
chown -R nobody.nobody '${PROJECT_NAME}'/config_auto.php
chown -R nobody.nobody '${PROJECT_NAME}'/global/configure/alipay.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/global/configure/flash.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/global/configure/quick_worker_config.php
chown -R nobody.nobody '${PROJECT_NAME}'/global/configure/tiktok_config.php
chown -R nobody.nobody '${PROJECT_NAME}'/global/configure/wechat_auth.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/global/configure/weixin.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/global/configure/replace.php
chown -R nobody.nobody '${PROJECT_NAME}'/v2.0/global/configure/alipay.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/v2.0/global/configure/flash.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/v2.0/global/configure/other.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/v2.0/global/configure/wechat_auth.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/v2.0/global/configure/weixin.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/v2.0/lib/alipay/key
chown -R nobody.nobody '${PROJECT_NAME}'/v2.0/global/configure/replace.php
chown -R nobody.nobody '${PROJECT_NAME}'/lib/alipay/key
chown -R nobody.nobody '${PROJECT_NAME}'/game_box/v1.0/global/configure/replace.php
chown -R nobody.nobody '${PROJECT_NAME}'/game_box/v1.0/global/configure/weixin.config.php
chown -R nobody.nobody '${PROJECT_NAME}'/min_game/global/configure/replace.php
chown -R nobody.nobody '${PROJECT_NAME}'/wechat_account_recharge/global/configure/replace.php
chown -R nobody.nobody '${PROJECT_NAME}'/wechat_account_recharge/global/configure/weixin.config.php
chmod -R 660 '${PROJECT_NAME}'/config_auto.php
chmod -R 660 '${PROJECT_NAME}'/global/configure/alipay.config.php
chmod -R 660 '${PROJECT_NAME}'/global/configure/flash.config.php
chmod -R 660 '${PROJECT_NAME}'/global/configure/quick_worker_config.php
chmod -R 660 '${PROJECT_NAME}'/global/configure/tiktok_config.php
chmod -R 660 '${PROJECT_NAME}'/global/configure/wechat_auth.config.php
chmod -R 660 '${PROJECT_NAME}'/global/configure/weixin.config.php
chmod -R 660 '${PROJECT_NAME}'/global/configure/replace.php
chmod -R 660 '${PROJECT_NAME}'/v2.0/global/configure/alipay.config.php
chmod -R 660 '${PROJECT_NAME}'/v2.0/global/configure/flash.config.php
chmod -R 660 '${PROJECT_NAME}'/v2.0/global/configure/other.config.php
chmod -R 660 '${PROJECT_NAME}'/v2.0/global/configure/wechat_auth.config.php
chmod -R 660 '${PROJECT_NAME}'/v2.0/global/configure/weixin.config.php
chmod -R 750 '${PROJECT_NAME}'/v2.0/lib/alipay/key
chmod -R 660 '${PROJECT_NAME}'/v2.0/global/configure/replace.php
chmod -R 750 '${PROJECT_NAME}'/lib/alipay/key
chmod -R 660 '${PROJECT_NAME}'/game_box/v1.0/global/configure/replace.php
chmod -R 660 '${PROJECT_NAME}'/game_box/v1.0/global/configure/weixin.config.php
chmod -R 660 '${PROJECT_NAME}'/min_game/global/configure/replace.php
chmod -R 660 '${PROJECT_NAME}'/wechat_account_recharge/global/configure/replace.php
chmod -R 660 '${PROJECT_NAME}'/wechat_account_recharge/global/configure/weixin.config.php'
echo "修改web-pre 配置文件和秘钥权限"
fi

